/*
    CharityWorld: PNGRaster.m
    Copyright (C) 2003  Macaulay Institute

    This file is part of CharityWorld, a simple agent-based model to
    demonstrate the effects of errors in floating point arithmetic on
    emergent outcomes.

    CharityWorld is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    CharityWorld is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details. (LICENCE file in
    this directory.)

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information:
      Gary Polhill,
      Macaulay Institute, Craigiebuckler, Aberdeen, AB15 8QH. United Kingdom
      g.polhill@macaulay.ac.uk
*/

#import "PNGRaster.h"
#import <stdlib.h>
#import <string.h>
#import <stdio.h>

@implementation PNGRaster

+create: aZone setRaster: (id <Raster>)r {
  PNGRaster *obj = [super create: aZone];

  obj->ras = r;
  obj->counter = 0;
  obj->filename_counter_width = 6;

  return obj;
}

+create: aZone setRaster: (id <Raster>)r counterWidth: (int)c {
  PNGRaster *obj = [self create: aZone setRaster: r];

  obj->filename_counter_width = c;

  return obj;
}

-saveToFileStem: (const char *)stem {
  int length = strlen(stem) + filename_counter_width + 7;
  char *buf = (char *)malloc(length + 1);
  id <Pixmap> map = [Pixmap createBegin: [self getZone]];

  [map setWidget: ras];

  map = [map createEnd];

  if(buf == NULL) {
    perror("Memory allocation");
    abort();
  }
  counter++;
  snprintf(buf, length, "%s-%0*d.png", stem, filename_counter_width, counter);

  printf("Saving PNG file %s...\n", buf);
  [map save: buf];
  printf("...done\n");

  free(buf);

  [map drop];
  return self;
}

-(void)drop {
  [super drop];
}

@end

  
